# -*- coding: utf-8 -*-
from setuphelpers import *
from common import WaptServer
import platform

name_menu = "Wads Deploy"
guid = "{2bdabb2b-eb21-11ec-ba0b-c85b76537da2}"
loc_folder = "wadswinpe"
loc_systemdrive = systemdrive()
full_loc_folder = makepath(loc_systemdrive, loc_folder)


def install():

    if params.get("install_with_luti", False):
        return "OK"

    error("This package is protect against accidental launch, to disable the protection, edit the package and remove this line")

    if not isdir(full_loc_folder):
        mkdirs(full_loc_folder)

    if not isfile("boot.sdi"):
        update_package(from_setup=True)

    filecopyto("boot.sdi", makepath(full_loc_folder, "boot.sdi"))
    filecopyto("boot.wim", makepath(full_loc_folder, "boot.wim"))

    # TODO INTEGRER DANS LE Boot.wim avec 7zip les drivers déjà existant sur la machine on pourrait même extraire les profiles wifi pour faire un déploiement par wifi

    wait_deploy = False

    myip = get_main_ip(WAPT.waptserver.server_url.split('//')[1])[0]

    for net in [u["mac"] for u in networking()]:
        dataipxe = WAPT.waptserver.get("api/v3/get_host_ipxe?mac_address=%s&ip_address=%s" % (net,myip), decode_json=False).decode("utf-8")
        if ("wads/winpe/x64" in dataipxe) and (not "registerwinpe" in dataipxe):
            wait_deploy = True
            break

    if wait_deploy:
        run(r'bcdedit /create {ramdiskoptions} /d "%s"' % name_menu)
        run(r"bcdedit /set {ramdiskoptions} ramdisksdidevice partition=%s" % loc_systemdrive)
        run(r"bcdedit /set {ramdiskoptions} ramdisksdipath \%s\boot.sdi" % loc_folder)
        run(r'bcdedit /create %s /d "%s" /application OSLOADER' % (guid, name_menu))
        run(r"bcdedit /set %s device ramdisk=[%s]\%s\boot.wim,{ramdiskoptions}" % (guid, loc_systemdrive, loc_folder))
        run(r"bcdedit /set %s osdevice ramdisk=[%s]\%s\boot.wim,{ramdiskoptions}" % (guid, loc_systemdrive, loc_folder))
        run(r"bcdedit /set %s systemroot \windows" % guid)
        run(r"bcdedit /set %s winpe yes" % guid)
        run(r"bcdedit /set %s detecthal yes" % guid)
        run(r"bcdedit /displayorder %s /addlast" % guid)
        run(r"bcdedit /default %s" % guid)
        run(r"bcdedit /timeout 5")
        run("shutdown /f /r /t 0")
    else:
        print("Skip, run installation")



def update_package(from_setup=None):

    urlserver = WAPT.waptserver.server_url
    old_version = control.get_software_version()

    if not from_setup == True:
        WAPT.waptserver.client_certificate = None
        WAPT.waptserver.client_private_key = None
    with WAPT.waptserver.get_requests_session() as session:
        wget("%s/wads/winpe/x64/media/Boot/boot.sdi" % (urlserver), "boot.sdi", requests_session=session)
        wget("%s/wads/winpe/x64/media/sources/boot.wim" % (urlserver), "boot.wim", requests_session=session)

    if not from_setup == True:
        version = control.version.split("-")[0]
        version_package = str(int(control.version.split("-")[1]) + 1)
        control.version = version + "-" + version_package
        control.save_control_to_wapt()


def uninstall():
    if isdir(full_loc_folder):
        remove_tree(full_loc_folder)
